require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_PARISC_ATOMIC_H_)) {
    eval 'sub _ASM_PARISC_ATOMIC_H_ () {1;}' unless defined(&_ASM_PARISC_ATOMIC_H_);
    if(defined(&__KERNEL__)) {
	require 'linux/types.ph';
	require 'asm/system.ph';
	if(defined(&CONFIG_SMP)) {
	    require 'asm/spinlock.ph';
	    require 'asm/cache.ph';
	    eval 'sub ATOMIC_HASH_SIZE () {4;}' unless defined(&ATOMIC_HASH_SIZE);
	    eval 'sub ATOMIC_HASH {
	        my($a) = @_;
    		eval q((( $__atomic_hash[ (( $a)/ &L1_CACHE_BYTES) & ( &ATOMIC_HASH_SIZE-1) ])));
	    }' unless defined(&ATOMIC_HASH);
	    eval 'sub _atomic_spin_lock_irqsave {
	        my($l,$f) = @_;
    		eval q( &do {  &raw_spinlock_t * &s =  &ATOMIC_HASH($l);  &local_irq_save($f);  &__raw_spin_lock( &s); }  &while(0));
	    }' unless defined(&_atomic_spin_lock_irqsave);
	    eval 'sub _atomic_spin_unlock_irqrestore {
	        my($l,$f) = @_;
    		eval q( &do {  &raw_spinlock_t * &s =  &ATOMIC_HASH($l);  &__raw_spin_unlock( &s);  &local_irq_restore($f); }  &while(0));
	    }' unless defined(&_atomic_spin_unlock_irqrestore);
	} else {
	    eval 'sub _atomic_spin_lock_irqsave {
	        my($l,$f) = @_;
    		eval q( &do {  &local_irq_save($f); }  &while (0));
	    }' unless defined(&_atomic_spin_lock_irqsave);
	    eval 'sub _atomic_spin_unlock_irqrestore {
	        my($l,$f) = @_;
    		eval q( &do {  &local_irq_restore($f); }  &while (0));
	    }' unless defined(&_atomic_spin_unlock_irqrestore);
	}
	if(defined(&__LP64__)) {
	}
	if(defined(&__LP64__)) {
	}
	eval 'sub xchg {
	    my($ptr,$x) = @_;
    	    eval q((( &__typeof__(*($ptr))) &__xchg(($x),($ptr),$sizeof{($ptr)})));
	}' unless defined(&xchg);
    }
    eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
    if(defined(&__LP64__)) {
    }
    eval 'sub cmpxchg {
        my($ptr,$o,$n) = @_;
	    eval q(({  &__typeof__(*($ptr))  &_o_ = ($o);  &__typeof__(*($ptr))  &_n_ = ($n); ( &__typeof__(*($ptr)))  &__cmpxchg(($ptr),  &_o_,  &_n_, $sizeof{($ptr)}); }));
    }' unless defined(&cmpxchg);
    eval 'sub atomic_set {
        my($v,$i) = @_;
	    eval q({ my $flags;  &_atomic_spin_lock_irqsave($v,  $flags);  ($v->{counter}) = $i;  &_atomic_spin_unlock_irqrestore($v,  $flags); });
    }' unless defined(&atomic_set);
    eval 'sub atomic_read {
        my($v) = @_;
	    eval q({  ($v->{counter}); });
    }' unless defined(&atomic_read);
    eval 'sub atomic_cmpxchg {
        my($v, $o, $n) = @_;
	    eval q(( &cmpxchg((($v)-> &counter), ($o), ($n))));
    }' unless defined(&atomic_cmpxchg);
    eval 'sub atomic_xchg {
        my($v, $new) = @_;
	    eval q(( &xchg((($v)-> &counter), $new)));
    }' unless defined(&atomic_xchg);
    eval 'sub atomic_add_unless {
        my($v, $a, $u) = @_;
	    eval q(({ \'int\'  &c,  &old;  &c =  &atomic_read($v);  &while ( &c != ($u)  && ( &old =  &atomic_cmpxchg(($v),  &c,  &c + ($a))) !=  &c)  &c =  &old;  &c != ($u); }));
    }' unless defined(&atomic_add_unless);
    eval 'sub atomic_inc_not_zero {
        my($v) = @_;
	    eval q( &atomic_add_unless(($v), 1, 0));
    }' unless defined(&atomic_inc_not_zero);
    eval 'sub atomic_add {
        my($i,$v) = @_;
	    eval q((( &void)( &__atomic_add_return( ($i),($v)))));
    }' unless defined(&atomic_add);
    eval 'sub atomic_sub {
        my($i,$v) = @_;
	    eval q((( &void)( &__atomic_add_return(-($i),($v)))));
    }' unless defined(&atomic_sub);
    eval 'sub atomic_inc {
        my($v) = @_;
	    eval q((( &void)( &__atomic_add_return( 1,($v)))));
    }' unless defined(&atomic_inc);
    eval 'sub atomic_dec {
        my($v) = @_;
	    eval q((( &void)( &__atomic_add_return( -1,($v)))));
    }' unless defined(&atomic_dec);
    eval 'sub atomic_add_return {
        my($i,$v) = @_;
	    eval q(( &__atomic_add_return( ($i),($v))));
    }' unless defined(&atomic_add_return);
    eval 'sub atomic_sub_return {
        my($i,$v) = @_;
	    eval q(( &__atomic_add_return(-($i),($v))));
    }' unless defined(&atomic_sub_return);
    eval 'sub atomic_inc_return {
        my($v) = @_;
	    eval q(( &__atomic_add_return( 1,($v))));
    }' unless defined(&atomic_inc_return);
    eval 'sub atomic_dec_return {
        my($v) = @_;
	    eval q(( &__atomic_add_return( -1,($v))));
    }' unless defined(&atomic_dec_return);
    eval 'sub atomic_add_negative {
        my($a, $v) = @_;
	    eval q(( &atomic_add_return(($a), ($v)) < 0));
    }' unless defined(&atomic_add_negative);
    eval 'sub atomic_inc_and_test {
        my($v) = @_;
	    eval q(( &atomic_inc_return($v) == 0));
    }' unless defined(&atomic_inc_and_test);
    eval 'sub atomic_dec_and_test {
        my($v) = @_;
	    eval q(( &atomic_dec_return($v) == 0));
    }' unless defined(&atomic_dec_and_test);
    eval 'sub atomic_sub_and_test {
        my($i,$v) = @_;
	    eval q(( &atomic_sub_return(($i),($v)) == 0));
    }' unless defined(&atomic_sub_and_test);
    eval 'sub ATOMIC_INIT {
        my($i) = @_;
	    eval q((( &atomic_t) { ($i) }));
    }' unless defined(&ATOMIC_INIT);
    eval 'sub smp_mb__before_atomic_dec () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__before_atomic_dec);
    eval 'sub smp_mb__after_atomic_dec () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__after_atomic_dec);
    eval 'sub smp_mb__before_atomic_inc () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__before_atomic_inc);
    eval 'sub smp_mb__after_atomic_inc () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__after_atomic_inc);
    if(defined(&__LP64__)) {
	eval 'sub ATOMIC64_INIT {
	    my($i) = @_;
    	    eval q((( &atomic64_t) { ($i) }));
	}' unless defined(&ATOMIC64_INIT);
	eval 'sub __atomic64_add_return {
	    my($i,$v) = @_;
    	    eval q({ \'int\'  &ret; my $flags;  &_atomic_spin_lock_irqsave($v,  $flags);  &ret = ( ($v->{counter}) += $i);  &_atomic_spin_unlock_irqrestore($v,  $flags);  &ret; });
	}' unless defined(&__atomic64_add_return);
	eval 'sub atomic64_set {
	    my($v,$i) = @_;
    	    eval q({ my $flags;  &_atomic_spin_lock_irqsave($v,  $flags);  ($v->{counter}) = $i;  &_atomic_spin_unlock_irqrestore($v,  $flags); });
	}' unless defined(&atomic64_set);
	eval 'sub atomic64_read {
	    my($v) = @_;
    	    eval q({  ($v->{counter}); });
	}' unless defined(&atomic64_read);
	eval 'sub atomic64_add {
	    my($i,$v) = @_;
    	    eval q((( &void)( &__atomic64_add_return( (( &s64)$i),($v)))));
	}' unless defined(&atomic64_add);
	eval 'sub atomic64_sub {
	    my($i,$v) = @_;
    	    eval q((( &void)( &__atomic64_add_return(-(( &s64)$i),($v)))));
	}' unless defined(&atomic64_sub);
	eval 'sub atomic64_inc {
	    my($v) = @_;
    	    eval q((( &void)( &__atomic64_add_return( 1,($v)))));
	}' unless defined(&atomic64_inc);
	eval 'sub atomic64_dec {
	    my($v) = @_;
    	    eval q((( &void)( &__atomic64_add_return( -1,($v)))));
	}' unless defined(&atomic64_dec);
	eval 'sub atomic64_add_return {
	    my($i,$v) = @_;
    	    eval q(( &__atomic64_add_return( (( &s64)$i),($v))));
	}' unless defined(&atomic64_add_return);
	eval 'sub atomic64_sub_return {
	    my($i,$v) = @_;
    	    eval q(( &__atomic64_add_return(-(( &s64)$i),($v))));
	}' unless defined(&atomic64_sub_return);
	eval 'sub atomic64_inc_return {
	    my($v) = @_;
    	    eval q(( &__atomic64_add_return( 1,($v))));
	}' unless defined(&atomic64_inc_return);
	eval 'sub atomic64_dec_return {
	    my($v) = @_;
    	    eval q(( &__atomic64_add_return( -1,($v))));
	}' unless defined(&atomic64_dec_return);
	eval 'sub atomic64_add_negative {
	    my($a, $v) = @_;
    	    eval q(( &atomic64_add_return(($a), ($v)) < 0));
	}' unless defined(&atomic64_add_negative);
	eval 'sub atomic64_inc_and_test {
	    my($v) = @_;
    	    eval q(( &atomic64_inc_return($v) == 0));
	}' unless defined(&atomic64_inc_and_test);
	eval 'sub atomic64_dec_and_test {
	    my($v) = @_;
    	    eval q(( &atomic64_dec_return($v) == 0));
	}' unless defined(&atomic64_dec_and_test);
	eval 'sub atomic64_sub_and_test {
	    my($i,$v) = @_;
    	    eval q(( &atomic64_sub_return(($i),($v)) == 0));
	}' unless defined(&atomic64_sub_and_test);
    }
    require 'asm-generic/atomic.ph';
}
1;
