require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_BITOPS_H)) {
    eval 'sub _PARISC_BITOPS_H () {1;}' unless defined(&_PARISC_BITOPS_H);
    require 'linux/compiler.ph';
    require 'asm/types.ph';
    require 'asm/byteorder.ph';
    require 'asm/atomic.ph';
    eval 'sub CHOP_SHIFTCOUNT {
        my($x) = @_;
	    eval q((( ($x)) & ( &BITS_PER_LONG - 1)));
    }' unless defined(&CHOP_SHIFTCOUNT);
    eval 'sub smp_mb__before_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__before_clear_bit);
    eval 'sub smp_mb__after_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__after_clear_bit);
    eval 'sub clear_bit {
        my($nr,$addr) = @_;
	    eval q({ my $mask = ~(1 <<  &CHOP_SHIFTCOUNT($nr)); my $flags; $addr += ($nr >>  &SHIFT_PER_LONG);  &_atomic_spin_lock_irqsave($addr,  $flags); *$addr &=  $mask;  &_atomic_spin_unlock_irqrestore($addr,  $flags); });
    }' unless defined(&clear_bit);
    eval 'sub change_bit {
        my($nr,$addr) = @_;
	    eval q({ my $mask = 1 <<  &CHOP_SHIFTCOUNT($nr); my $flags; $addr += ($nr >>  &SHIFT_PER_LONG);  &_atomic_spin_lock_irqsave($addr,  $flags); *$addr ^=  $mask;  &_atomic_spin_unlock_irqrestore($addr,  $flags); });
    }' unless defined(&change_bit);
    eval 'sub test_and_set_bit {
        my($nr,$addr) = @_;
	    eval q({ my $mask = 1 <<  &CHOP_SHIFTCOUNT($nr); my $oldbit; my $flags; $addr += ($nr >>  &SHIFT_PER_LONG);  &_atomic_spin_lock_irqsave($addr,  $flags);  $oldbit = *$addr; *$addr =  $oldbit |  $mask;  &_atomic_spin_unlock_irqrestore($addr,  $flags); ( $oldbit &  $mask) ? 1: 0; });
    }' unless defined(&test_and_set_bit);
    eval 'sub test_and_clear_bit {
        my($nr,$addr) = @_;
	    eval q({ my $mask = 1 <<  &CHOP_SHIFTCOUNT($nr); my $oldbit; my $flags; $addr += ($nr >>  &SHIFT_PER_LONG);  &_atomic_spin_lock_irqsave($addr,  $flags);  $oldbit = *$addr; *$addr =  $oldbit & ~ $mask;  &_atomic_spin_unlock_irqrestore($addr,  $flags); ( $oldbit &  $mask) ? 1: 0; });
    }' unless defined(&test_and_clear_bit);
    eval 'sub test_and_change_bit {
        my($nr,$addr) = @_;
	    eval q({ my $mask = 1 <<  &CHOP_SHIFTCOUNT($nr); my $oldbit; my $flags; $addr += ($nr >>  &SHIFT_PER_LONG);  &_atomic_spin_lock_irqsave($addr,  $flags);  $oldbit = *$addr; *$addr =  $oldbit ^  $mask;  &_atomic_spin_unlock_irqrestore($addr,  $flags); ( $oldbit &  $mask) ? 1: 0; });
    }' unless defined(&test_and_change_bit);
    require 'asm-generic/bitops/non-atomic.ph';
    if(defined(&__KERNEL__)) {
	if(defined(&__LP64__)) {
	} else {
	}
	require 'asm-generic/bitops/ffz.ph';
	require 'asm-generic/bitops/fls64.ph';
	require 'asm-generic/bitops/hweight.ph';
	require 'asm-generic/bitops/sched.ph';
    }
    require 'asm-generic/bitops/find.ph';
    if(defined(&__KERNEL__)) {
	require 'asm-generic/bitops/ext2-non-atomic.ph';
	eval 'sub LE_BYTE_ADDR () {(($sizeof{\'unsigned long\'} - 1) << 3);}' unless defined(&LE_BYTE_ADDR);
	eval 'sub ext2_set_bit_atomic {
	    my($l,$nr,$addr) = @_;
    	    eval q( &test_and_set_bit(($nr) ^  &LE_BYTE_ADDR, $addr));
	}' unless defined(&ext2_set_bit_atomic);
	eval 'sub ext2_clear_bit_atomic {
	    my($l,$nr,$addr) = @_;
    	    eval q( &test_and_clear_bit( ($nr) ^  &LE_BYTE_ADDR, $addr));
	}' unless defined(&ext2_clear_bit_atomic);
    }
    require 'asm-generic/bitops/minix-le.ph';
}
1;
