require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_PAGE_H)) {
    eval 'sub _PARISC_PAGE_H () {1;}' unless defined(&_PARISC_PAGE_H);
    if(defined(&__KERNEL__)) {
	if(defined( &CONFIG_PARISC_PAGE_SIZE_4KB)) {
	    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
	}
 elsif(defined( &CONFIG_PARISC_PAGE_SIZE_16KB)) {
	    eval 'sub PAGE_SHIFT () {14;}' unless defined(&PAGE_SHIFT);
	}
 elsif(defined( &CONFIG_PARISC_PAGE_SIZE_64KB)) {
	    eval 'sub PAGE_SHIFT () {16;}' unless defined(&PAGE_SHIFT);
	} else {
	    die("unknown default kernel page size");
	}
	eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
	eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
	unless(defined(&__ASSEMBLY__)) {
	    require 'asm/types.ph';
	    require 'asm/cache.ph';
	    eval 'sub clear_page {
	        my($page) = @_;
    		eval q( &memset(( &void *)($page), 0,  &PAGE_SIZE));
	    }' unless defined(&clear_page);
	    eval 'sub copy_page {
	        my($to,$from) = @_;
    		eval q( &copy_user_page_asm(( &void *)($to), ( &void *)($from)));
	    }' unless defined(&copy_page);
	    eval 'sub STRICT_MM_TYPECHECKS () {1;}' unless defined(&STRICT_MM_TYPECHECKS);
	    if(defined(&STRICT_MM_TYPECHECKS)) {
		if(!defined( &CONFIG_64BIT)) {
		}
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q((($x). &pte));
		}' unless defined(&pte_val);
		eval 'sub pmd_val {
		    my($x) = @_;
    		    eval q((($x). &pmd + 0));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    my($x) = @_;
    		    eval q((($x). &pgd + 0));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    my($x) = @_;
    		    eval q((($x). &pgprot));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    my($x) = @_;
    		    eval q((( &pte_t) { ($x) } ));
		}' unless defined(&__pte);
		eval 'sub __pmd {
		    my($x) = @_;
    		    eval q((( &pmd_t) { ($x) } ));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    my($x) = @_;
    		    eval q((( &pgd_t) { ($x) } ));
		}' unless defined(&__pgd);
		eval 'sub __pgprot {
		    my($x) = @_;
    		    eval q((( &pgprot_t) { ($x) } ));
		}' unless defined(&__pgprot);
		eval 'sub __pmd_val_set {
		    my($x,$n) = @_;
    		    eval q(($x). &pmd = ($n));
		}' unless defined(&__pmd_val_set);
		eval 'sub __pgd_val_set {
		    my($x,$n) = @_;
    		    eval q(($x). &pgd = ($n));
		}' unless defined(&__pgd_val_set);
	    } else {
		eval 'sub pte_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pte_val);
		eval 'sub pmd_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pmd_val);
		eval 'sub pgd_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgd_val);
		eval 'sub pgprot_val {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&pgprot_val);
		eval 'sub __pte {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pte);
		eval 'sub __pmd {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pmd);
		eval 'sub __pgd {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgd);
		eval 'sub __pgprot {
		    my($x) = @_;
    		    eval q(($x));
		}' unless defined(&__pgprot);
		eval 'sub __pmd_val_set {
		    my($x,$n) = @_;
    		    eval q(($x) = ($n));
		}' unless defined(&__pmd_val_set);
		eval 'sub __pgd_val_set {
		    my($x,$n) = @_;
    		    eval q(($x) = ($n));
		}' unless defined(&__pgd_val_set);
	    }
	}
	if(defined(&__LP64__)) {
	    eval 'sub BITS_PER_PTE_ENTRY () {3;}' unless defined(&BITS_PER_PTE_ENTRY);
	    eval 'sub BITS_PER_PMD_ENTRY () {2;}' unless defined(&BITS_PER_PMD_ENTRY);
	    eval 'sub BITS_PER_PGD_ENTRY () {2;}' unless defined(&BITS_PER_PGD_ENTRY);
	} else {
	    eval 'sub BITS_PER_PTE_ENTRY () {3;}' unless defined(&BITS_PER_PTE_ENTRY);
	    eval 'sub BITS_PER_PMD_ENTRY () {2;}' unless defined(&BITS_PER_PMD_ENTRY);
	    eval 'sub BITS_PER_PGD_ENTRY () { &BITS_PER_PMD_ENTRY;}' unless defined(&BITS_PER_PGD_ENTRY);
	}
	eval 'sub PGD_ENTRY_SIZE () {(1 <<  &BITS_PER_PGD_ENTRY);}' unless defined(&PGD_ENTRY_SIZE);
	eval 'sub PMD_ENTRY_SIZE () {(1 <<  &BITS_PER_PMD_ENTRY);}' unless defined(&PMD_ENTRY_SIZE);
	eval 'sub PTE_ENTRY_SIZE () {(1 <<  &BITS_PER_PTE_ENTRY);}' unless defined(&PTE_ENTRY_SIZE);
	eval 'sub PAGE_ALIGN {
	    my($addr) = @_;
    	    eval q(((($addr)+ &PAGE_SIZE-1) &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub LINUX_GATEWAY_SPACE () {0;}' unless defined(&LINUX_GATEWAY_SPACE);
	eval 'sub __PAGE_OFFSET () {(0x10000000);}' unless defined(&__PAGE_OFFSET);
	eval 'sub PAGE_OFFSET () {( &__PAGE_OFFSET);}' unless defined(&PAGE_OFFSET);
	eval 'sub GATEWAY_PAGE_SIZE () {0x4000;}' unless defined(&GATEWAY_PAGE_SIZE);
	eval 'sub KERNEL_BINARY_TEXT_START () {( &__PAGE_OFFSET + 0x100000);}' unless defined(&KERNEL_BINARY_TEXT_START);
	if(defined(&__ASSEMBLY__)) {
	    eval 'sub PA {
	        my($x) = @_;
    		eval q((($x)- &__PAGE_OFFSET));
	    }' unless defined(&PA);
	    eval 'sub VA {
	        my($x) = @_;
    		eval q((($x)+ &__PAGE_OFFSET));
	    }' unless defined(&VA);
	}
	eval 'sub __pa {
	    my($x) = @_;
    	    eval q((($x)- &PAGE_OFFSET));
	}' unless defined(&__pa);
	eval 'sub __va {
	    my($x) = @_;
    	    eval q((( &void *)(($x)+ &PAGE_OFFSET)));
	}' unless defined(&__va);
	unless(defined(&CONFIG_DISCONTIGMEM)) {
	    eval 'sub pfn_valid {
	        my($pfn) = @_;
    		eval q((($pfn) <  &max_mapnr));
	    }' unless defined(&pfn_valid);
	}
	if(defined(&CONFIG_HUGETLB_PAGE)) {
	    eval 'sub HPAGE_SHIFT () {22;}' unless defined(&HPAGE_SHIFT);
	    eval 'sub HPAGE_SIZE () {((1) <<  &HPAGE_SHIFT);}' unless defined(&HPAGE_SIZE);
	    eval 'sub HPAGE_MASK () {(~( &HPAGE_SIZE - 1));}' unless defined(&HPAGE_MASK);
	    eval 'sub HUGETLB_PAGE_ORDER () {( &HPAGE_SHIFT -  &PAGE_SHIFT);}' unless defined(&HUGETLB_PAGE_ORDER);
	}
	eval 'sub virt_addr_valid {
	    my($kaddr) = @_;
    	    eval q( &pfn_valid( &__pa($kaddr) >>  &PAGE_SHIFT));
	}' unless defined(&virt_addr_valid);
	eval 'sub page_to_phys {
	    my($page) = @_;
    	    eval q(( &page_to_pfn($page) <<  &PAGE_SHIFT));
	}' unless defined(&page_to_phys);
	eval 'sub virt_to_page {
	    my($kaddr) = @_;
    	    eval q( &pfn_to_page( &__pa($kaddr) >>  &PAGE_SHIFT));
	}' unless defined(&virt_to_page);
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
	require 'asm-generic/memory_model.ph';
	require 'asm-generic/page.ph';
    }
}
1;
