require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__PARISC_SYSTEM_H)) {
    eval 'sub __PARISC_SYSTEM_H () {1;}' unless defined(&__PARISC_SYSTEM_H);
    if(defined(&__KERNEL__)) {
	require 'asm/psw.ph';
	if(defined(&__LP64__)) {
	    eval 'sub pa_psw {
	        my($task) = @_;
    		eval q(( ( ($task) +  &TASK_PT_PSW + 4)));
	    }' unless defined(&pa_psw);
	} else {
	    eval 'sub pa_psw {
	        my($task) = @_;
    		eval q(( ( ($task) +  &TASK_PT_PSW)));
	    }' unless defined(&pa_psw);
	}
	eval 'sub switch_to {
	    my($prev, $next, $last) = @_;
    	    eval q( &do { ($last) =  &_switch_to($prev, $next); }  &while(0));
	}' unless defined(&switch_to);
	eval 'sub local_save_flags {
	    my($x) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&local_save_flags);
	eval 'sub local_irq_disable () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&local_irq_disable);
	eval 'sub local_irq_enable () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&local_irq_enable);
	eval 'sub local_irq_save {
	    my($x) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&local_irq_save);
	eval 'sub local_irq_restore {
	    my($x) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&local_irq_restore);
	eval 'sub irqs_disabled () {
	    eval q(({ \'unsigned long flags\';  &local_save_flags( &flags); ( &flags &  &PSW_I) == 0; }));
	}' unless defined(&irqs_disabled);
	eval 'sub mfctl {
	    my($reg) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&mfctl);
	eval 'sub mtctl {
	    my($gr, $cr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&mtctl);
	eval 'sub get_eiem () {
	    eval q( &mfctl(15));
	}' unless defined(&get_eiem);
	eval 'sub set_eiem {
	    my($val) = @_;
    	    eval q({  &mtctl($val, 15); });
	}' unless defined(&set_eiem);
	eval 'sub mfsp {
	    my($reg) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&mfsp);
	eval 'sub mtsp {
	    my($gr, $cr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&mtsp);
	eval 'sub mb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &mb());
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &mb());
	}' unless defined(&wmb);
	eval 'sub smp_mb () {
	    eval q( &mb());
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &mb());
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &mb());
	}' unless defined(&smp_wmb);
	eval 'sub smp_read_barrier_depends () {
	    eval q( &do { }  &while(0));
	}' unless defined(&smp_read_barrier_depends);
	eval 'sub read_barrier_depends () {
	    eval q( &do { }  &while(0));
	}' unless defined(&read_barrier_depends);
	eval 'sub set_mb {
	    my($var, $value) = @_;
    	    eval q( &do { $var = $value;  &mb(); }  &while (0));
	}' unless defined(&set_mb);
	unless(defined(&CONFIG_PA20)) {
	    eval 'sub __PA_LDCW_ALIGNMENT () {16;}' unless defined(&__PA_LDCW_ALIGNMENT);
	    eval 'sub __ldcw_align {
	        my($a) = @_;
    		eval q(({ \'unsigned long __ret\' =  ($a)-> $lock[0];  &__ret = ( &__ret +  &__PA_LDCW_ALIGNMENT - 1) & ~( &__PA_LDCW_ALIGNMENT - 1); ( &volatile \'unsigned int\' *)  &__ret; }));
	    }' unless defined(&__ldcw_align);
	    eval 'sub __LDCW () {"ldcw";}' unless defined(&__LDCW);
	} else {
	    eval 'sub __PA_LDCW_ALIGNMENT () {4;}' unless defined(&__PA_LDCW_ALIGNMENT);
	    eval 'sub __ldcw_align {
	        my($a) = @_;
    		eval q((( &volatile \'unsigned int\' *)$a));
	    }' unless defined(&__ldcw_align);
	    eval 'sub __LDCW () {"ldcw,co";}' unless defined(&__LDCW);
	}
	eval 'sub __ldcw {
	    my($a) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__ldcw);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub __lock_aligned () { &__attribute__(( &__section__(".data.lock_aligned")));}' unless defined(&__lock_aligned);
	}
	eval 'sub KERNEL_START () {(0x10100000 - 0x1000);}' unless defined(&KERNEL_START);
	eval 'sub arch_align_stack {
	    my($x) = @_;
    	    eval q(($x));
	}' unless defined(&arch_align_stack);
    }
}
1;
